package com.yuandian.dataflow.proto;

import static io.grpc.MethodDescriptor.generateFullMethodName;
import static io.grpc.stub.ClientCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ClientCalls.asyncClientStreamingCall;
import static io.grpc.stub.ClientCalls.asyncServerStreamingCall;
import static io.grpc.stub.ClientCalls.asyncUnaryCall;
import static io.grpc.stub.ClientCalls.blockingServerStreamingCall;
import static io.grpc.stub.ClientCalls.blockingUnaryCall;
import static io.grpc.stub.ClientCalls.futureUnaryCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.32.3)",
    comments = "Source: Base.proto")
public final class CollectPacketsServerGrpc {

  private CollectPacketsServerGrpc() {}

  public static final String SERVICE_NAME = "dataflow.CollectPacketsServer";

  // Static method descriptors that strictly reflect the proto.
  private static volatile io.grpc.MethodDescriptor<com.yuandian.dataflow.proto.Base.Request,
      com.yuandian.dataflow.proto.Base.Response> getGetPacketsMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetPackets",
      requestType = com.yuandian.dataflow.proto.Base.Request.class,
      responseType = com.yuandian.dataflow.proto.Base.Response.class,
      methodType = io.grpc.MethodDescriptor.MethodType.SERVER_STREAMING)
  public static io.grpc.MethodDescriptor<com.yuandian.dataflow.proto.Base.Request,
      com.yuandian.dataflow.proto.Base.Response> getGetPacketsMethod() {
    io.grpc.MethodDescriptor<com.yuandian.dataflow.proto.Base.Request, com.yuandian.dataflow.proto.Base.Response> getGetPacketsMethod;
    if ((getGetPacketsMethod = CollectPacketsServerGrpc.getGetPacketsMethod) == null) {
      synchronized (CollectPacketsServerGrpc.class) {
        if ((getGetPacketsMethod = CollectPacketsServerGrpc.getGetPacketsMethod) == null) {
          CollectPacketsServerGrpc.getGetPacketsMethod = getGetPacketsMethod =
              io.grpc.MethodDescriptor.<com.yuandian.dataflow.proto.Base.Request, com.yuandian.dataflow.proto.Base.Response>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.SERVER_STREAMING)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetPackets"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.yuandian.dataflow.proto.Base.Request.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.yuandian.dataflow.proto.Base.Response.getDefaultInstance()))
              .setSchemaDescriptor(new CollectPacketsServerMethodDescriptorSupplier("GetPackets"))
              .build();
        }
      }
    }
    return getGetPacketsMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static CollectPacketsServerStub newStub(io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<CollectPacketsServerStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<CollectPacketsServerStub>() {
        @java.lang.Override
        public CollectPacketsServerStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new CollectPacketsServerStub(channel, callOptions);
        }
      };
    return CollectPacketsServerStub.newStub(factory, channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static CollectPacketsServerBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<CollectPacketsServerBlockingStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<CollectPacketsServerBlockingStub>() {
        @java.lang.Override
        public CollectPacketsServerBlockingStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new CollectPacketsServerBlockingStub(channel, callOptions);
        }
      };
    return CollectPacketsServerBlockingStub.newStub(factory, channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static CollectPacketsServerFutureStub newFutureStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<CollectPacketsServerFutureStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<CollectPacketsServerFutureStub>() {
        @java.lang.Override
        public CollectPacketsServerFutureStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new CollectPacketsServerFutureStub(channel, callOptions);
        }
      };
    return CollectPacketsServerFutureStub.newStub(factory, channel);
  }

  /**
   */
  public static abstract class CollectPacketsServerImplBase implements io.grpc.BindableService {

    /**
     */
    public void getPackets(com.yuandian.dataflow.proto.Base.Request request,
        io.grpc.stub.StreamObserver<com.yuandian.dataflow.proto.Base.Response> responseObserver) {
      asyncUnimplementedUnaryCall(getGetPacketsMethod(), responseObserver);
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getGetPacketsMethod(),
            asyncServerStreamingCall(
              new MethodHandlers<
                com.yuandian.dataflow.proto.Base.Request,
                com.yuandian.dataflow.proto.Base.Response>(
                  this, METHODID_GET_PACKETS)))
          .build();
    }
  }

  /**
   */
  public static final class CollectPacketsServerStub extends io.grpc.stub.AbstractAsyncStub<CollectPacketsServerStub> {
    private CollectPacketsServerStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected CollectPacketsServerStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new CollectPacketsServerStub(channel, callOptions);
    }

    /**
     */
    public void getPackets(com.yuandian.dataflow.proto.Base.Request request,
        io.grpc.stub.StreamObserver<com.yuandian.dataflow.proto.Base.Response> responseObserver) {
      asyncServerStreamingCall(
          getChannel().newCall(getGetPacketsMethod(), getCallOptions()), request, responseObserver);
    }
  }

  /**
   */
  public static final class CollectPacketsServerBlockingStub extends io.grpc.stub.AbstractBlockingStub<CollectPacketsServerBlockingStub> {
    private CollectPacketsServerBlockingStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected CollectPacketsServerBlockingStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new CollectPacketsServerBlockingStub(channel, callOptions);
    }

    /**
     */
    public java.util.Iterator<com.yuandian.dataflow.proto.Base.Response> getPackets(
        com.yuandian.dataflow.proto.Base.Request request) {
      return blockingServerStreamingCall(
          getChannel(), getGetPacketsMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class CollectPacketsServerFutureStub extends io.grpc.stub.AbstractFutureStub<CollectPacketsServerFutureStub> {
    private CollectPacketsServerFutureStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected CollectPacketsServerFutureStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new CollectPacketsServerFutureStub(channel, callOptions);
    }
  }

  private static final int METHODID_GET_PACKETS = 0;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final CollectPacketsServerImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(CollectPacketsServerImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_GET_PACKETS:
          serviceImpl.getPackets((com.yuandian.dataflow.proto.Base.Request) request,
              (io.grpc.stub.StreamObserver<com.yuandian.dataflow.proto.Base.Response>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class CollectPacketsServerBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    CollectPacketsServerBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return com.yuandian.dataflow.proto.Base.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("CollectPacketsServer");
    }
  }

  private static final class CollectPacketsServerFileDescriptorSupplier
      extends CollectPacketsServerBaseDescriptorSupplier {
    CollectPacketsServerFileDescriptorSupplier() {}
  }

  private static final class CollectPacketsServerMethodDescriptorSupplier
      extends CollectPacketsServerBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    CollectPacketsServerMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (CollectPacketsServerGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new CollectPacketsServerFileDescriptorSupplier())
              .addMethod(getGetPacketsMethod())
              .build();
        }
      }
    }
    return result;
  }
}
